---
title: >-
  SyntaxError: a declaration in the head of a for-of loop can't have an
  initializer
slug: Web/JavaScript/Reference/Errors/Invalid_for-of_initializer
tags:
  - Error
  - JavaScript
  - SyntaxError
---
<div>{{jsSidebar("Errors")}}</div>

<p>The JavaScript exception "a declaration in the head of a for-of loop can't have an initializer" occurs when the head of a<a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of"> for...of</a> loop contains an initializer expression such as |<code>for (var i = 0 of iterable)</code>|. This is not allowed in for-of loops.</p>

<h2 id="Message">Message</h2>

<pre class="syntaxbox">SyntaxError: for-of loop head declarations cannot have an initializer (Edge)
SyntaxError: a declaration in the head of a for-of loop can't have an initializer (Firefox)
SyntaxError: for-of loop variable declaration may not have an initializer. (Chrome)
</pre>

<h2 id="Error_type">Error type</h2>

<p>{{jsxref("SyntaxError")}}</p>

<h2 id="What_went_wrong">What went wrong?</h2>

<p>The head of a<a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of"> for...of</a> loop contains an initializer expression. That is, a variable is declared and assigned a value |<code>for (var i = 0 of iterable)</code>|. This is not allowed in for-of loops. You might want a <code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for">for</a></code> loop that does allow an initializer.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Invalid_for-of_loop">Invalid <code>for-of</code> loop</h3>

<pre class="brush: js example-bad">let iterable = [10, 20, 30];

for (let value = 50 of iterable) {
  console.log(value);
}

// SyntaxError: a declaration in the head of a for-of loop can't
// have an initializer</pre>

<h3 id="Valid_for-of_loop">Valid <code>for-of</code> loop</h3>

<p>You need to remove the initializer (<code>value = 50</code>) in the head of the <code>for-of</code> loop. Maybe you intended to make 50 an offset value, in that case you could add it to the loop body, for example.</p>

<pre class="brush: js example-good">let iterable = [10, 20, 30];

for (let value of iterable) {
  value += 50;
  console.log(value);
}
// 60
// 70
// 80
</pre>

<h2 id="See_also">See also</h2>

<ul>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...of">for...of</a></code></li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for...in">for...in</a></code> – disallows an initializer in strict mode as well (<a href="/en-US/docs/Web/JavaScript/Reference/Errors/Invalid_for-in_initializer">SyntaxError: for-in loop head declarations may not have initializers</a>)</li>
 <li><code><a href="/en-US/docs/Web/JavaScript/Reference/Statements/for">for</a></code> – allows to define an initializer when iterating.</li>
</ul>
